SDL_surface.h File Reference
`#include "SDL_stdinc.h"`
`#include "SDL_pixels.h"`
`#include "SDL_rect.h"`
`#include "SDL_blendmode.h"`
`#include "SDL_rwops.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_surface.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | SDL_Surface

## Surface flags

# CategorySurface

Header file for SDL_Surface definition and management functions.

These are the currently supported flags for the SDL_Surface.

Used internally (read-only).

#define | SDL_SWSURFACE 0
#define | SDL_PREALLOC 0x00000001
#define | SDL_RLEACCEL 0x00000002
#define | SDL_DONTFREE 0x00000004
#define | SDL_SIMD_ALIGNED 0x00000008
#define | SDL_MUSTLOCK(S)
#define | SDL_LoadBMP(file)
#define | SDL_SaveBMP(surface, file)
#define | SDL_BlitSurface SDL_UpperBlit
#define | SDL_BlitScaled SDL_UpperBlitScaled
enum | SDL_YUV_CONVERSION_MODE { SDL_YUV_CONVERSION_JPEG , SDL_YUV_CONVERSION_BT601 , SDL_YUV_CONVERSION_BT709 , SDL_YUV_CONVERSION_AUTOMATIC }
typedef struct SDL_BlitMap | SDL_BlitMap
typedef int(* | SDL_blit) (struct SDL_Surface *src, SDL_Rect *srcrect, struct SDL_Surface *dst, SDL_Rect *dstrect)
SDL_Surface * | SDL_CreateRGBSurface (Uint32 flags, int width, int height, int depth, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask)
SDL_Surface * | SDL_CreateRGBSurfaceWithFormat (Uint32 flags, int width, int height, int depth, Uint32 format)
SDL_Surface * | SDL_CreateRGBSurfaceFrom (void *pixels, int width, int height, int depth, int pitch, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask)
SDL_Surface * | SDL_CreateRGBSurfaceWithFormatFrom (void *pixels, int width, int height, int depth, int pitch, Uint32 format)
void | SDL_FreeSurface (SDL_Surface *surface)
int | SDL_SetSurfacePalette (SDL_Surface *surface, SDL_Palette *palette)
int | SDL_LockSurface (SDL_Surface *surface)
void | SDL_UnlockSurface (SDL_Surface *surface)
SDL_Surface * | SDL_LoadBMP_RW (SDL_RWops *src, int freesrc)
int | SDL_SaveBMP_RW (SDL_Surface *surface, SDL_RWops *dst, int freedst)
int | SDL_SetSurfaceRLE (SDL_Surface *surface, int flag)
SDL_bool | SDL_HasSurfaceRLE (SDL_Surface *surface)
int | SDL_SetColorKey (SDL_Surface *surface, int flag, Uint32 key)
SDL_bool | SDL_HasColorKey (SDL_Surface *surface)
int | SDL_GetColorKey (SDL_Surface *surface, Uint32 *key)
int | SDL_SetSurfaceColorMod (SDL_Surface *surface, Uint8 r, Uint8 g, Uint8 b)
int | SDL_GetSurfaceColorMod (SDL_Surface *surface, Uint8 *r, Uint8 *g, Uint8 *b)
int | SDL_SetSurfaceAlphaMod (SDL_Surface *surface, Uint8 alpha)
int | SDL_GetSurfaceAlphaMod (SDL_Surface *surface, Uint8 *alpha)
int | SDL_SetSurfaceBlendMode (SDL_Surface *surface, SDL_BlendMode blendMode)
int | SDL_GetSurfaceBlendMode (SDL_Surface *surface, SDL_BlendMode *blendMode)
SDL_bool | SDL_SetClipRect (SDL_Surface *surface, const SDL_Rect *rect)
void | SDL_GetClipRect (SDL_Surface *surface, SDL_Rect *rect)
SDL_Surface * | SDL_DuplicateSurface (SDL_Surface *surface)
SDL_Surface * | SDL_ConvertSurface (SDL_Surface *src, const SDL_PixelFormat *fmt, Uint32 flags)
SDL_Surface * | SDL_ConvertSurfaceFormat (SDL_Surface *src, Uint32 pixel_format, Uint32 flags)
int | SDL_ConvertPixels (int width, int height, Uint32 src_format, const void *src, int src_pitch, Uint32 dst_format, void *dst, int dst_pitch)
int | SDL_PremultiplyAlpha (int width, int height, Uint32 src_format, const void *src, int src_pitch, Uint32 dst_format, void *dst, int dst_pitch)
int | SDL_FillRect (SDL_Surface *dst, const SDL_Rect *rect, Uint32 color)
int | SDL_FillRects (SDL_Surface *dst, const SDL_Rect *rects, int count, Uint32 color)
int | SDL_UpperBlit (SDL_Surface *src, const SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect)
int | SDL_LowerBlit (SDL_Surface *src, SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect)
int | SDL_SoftStretch (SDL_Surface *src, const SDL_Rect *srcrect, SDL_Surface *dst, const SDL_Rect *dstrect)
int | SDL_SoftStretchLinear (SDL_Surface *src, const SDL_Rect *srcrect, SDL_Surface *dst, const SDL_Rect *dstrect)
int | SDL_UpperBlitScaled (SDL_Surface *src, const SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect)
int | SDL_LowerBlitScaled (SDL_Surface *src, SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect)
void | SDL_SetYUVConversionMode (SDL_YUV_CONVERSION_MODE mode)
SDL_YUV_CONVERSION_MODE | SDL_GetYUVConversionMode (void)
SDL_YUV_CONVERSION_MODE | SDL_GetYUVConversionModeForResolution (int width, int height)

## Macro Definition Documentation

## SDL_BlitScaled

#define SDL_BlitScaled SDL_UpperBlitScaled

Definition at line 945 of file SDL_surface.h.

## SDL_BlitSurface

#define SDL_BlitSurface SDL_UpperBlit

Performs a fast blit from the source surface to the destination surface.

This assumes that the source and destination rectangles are the same size. If either srcrect or dstrect are NULL, the entire surface (src or dst) is copied. The final blit rectangle is saved in dstrect after all clipping is performed.

The blit function should not be called on a locked surface.

The blit semantics for surfaces with and without blending and colorkey are defined as follows:

RGBA->RGB:
Source surface blend mode set to SDL_BLENDMODE_BLEND:
alpha-blend (using the source alpha-channel and per-surface alpha)
SDL_SRCCOLORKEY ignored.
Source surface blend mode set to SDL_BLENDMODE_NONE:
copy RGB.
if SDL_SRCCOLORKEY set, only copy the pixels matching the
RGB values of the source color key, ignoring alpha in the
comparison.
RGB->RGBA:
Source surface blend mode set to SDL_BLENDMODE_BLEND:
alpha-blend (using the source per-surface alpha)
Source surface blend mode set to SDL_BLENDMODE_NONE:
copy RGB, set destination alpha to source per-surface alpha value.
both:
if SDL_SRCCOLORKEY set, only copy the pixels matching the
source color key.
RGBA->RGBA:
Source surface blend mode set to SDL_BLENDMODE_BLEND:
alpha-blend (using the source alpha-channel and per-surface alpha)
SDL_SRCCOLORKEY ignored.
Source surface blend mode set to SDL_BLENDMODE_NONE:
copy all of RGBA to the destination.
if SDL_SRCCOLORKEY set, only copy the pixels matching the
RGB values of the source color key, ignoring alpha in the
comparison.
RGB->RGB:
Source surface blend mode set to SDL_BLENDMODE_BLEND:
alpha-blend (using the source per-surface alpha)
Source surface blend mode set to SDL_BLENDMODE_NONE:
copy RGB.
both:
if SDL_SRCCOLORKEY set, only copy the pixels matching the
source color key.
SDL_BLENDMODE_NONE
@ SDL_BLENDMODE_NONE
Definition SDL_blendmode.h:42
SDL_BLENDMODE_BLEND
@ SDL_BLENDMODE_BLEND
Definition SDL_blendmode.h:44

You should call SDL_BlitSurface() unless you know exactly how SDL blitting works internally and how to use the other blit functions.

Returns
  0 if the blit is successful, otherwise it returns -1.

Definition at line 864 of file SDL_surface.h.

## SDL_DONTFREE

#define SDL_DONTFREE 0x00000004

Surface is referenced internally

Definition at line 55 of file SDL_surface.h.

## SDL_LoadBMP

#define SDL_LoadBMP | ( |  | file | ) |

Value:
SDL_LoadBMP_RW(SDL_RWFromFile(file, "rb"), 1)
SDL_RWFromFile
SDL_RWops * SDL_RWFromFile(const char *file, const char *mode)
SDL_LoadBMP_RW
SDL_Surface * SDL_LoadBMP_RW(SDL_RWops *src, int freesrc)

Load a surface from a file.

Convenience macro.

Definition at line 356 of file SDL_surface.h.

## SDL_MUSTLOCK

#define SDL_MUSTLOCK | ( |  | S | ) |

Value:
(((S)->flags & SDL_RLEACCEL) != 0)
SDL_RLEACCEL
#define SDL_RLEACCEL
Definition SDL_surface.h:54

Evaluates to true if the surface needs to be locked before access.

Definition at line 62 of file SDL_surface.h.

## SDL_PREALLOC

#define SDL_PREALLOC 0x00000001

Surface uses preallocated memory

Definition at line 53 of file SDL_surface.h.

## SDL_RLEACCEL

#define SDL_RLEACCEL 0x00000002

Surface is RLE encoded

Definition at line 54 of file SDL_surface.h.

## SDL_SaveBMP

#define SDL_SaveBMP | ( |  | surface,
|  |  | file )

Value:
SDL_SaveBMP_RW(surface, SDL_RWFromFile(file, "wb"), 1)
SDL_SaveBMP_RW
int SDL_SaveBMP_RW(SDL_Surface *surface, SDL_RWops *dst, int freedst)

Save a surface to a file.

Convenience macro.

Definition at line 386 of file SDL_surface.h.

#define SDL_SaveBMP(surface, file) \
SDL_SaveBMP_RW(surface, SDL_RWFromFile(file, "wb"), 1)

## SDL_SIMD_ALIGNED

#define SDL_SIMD_ALIGNED 0x00000008

Surface uses aligned memory

Definition at line 56 of file SDL_surface.h.

## SDL_SWSURFACE

#define SDL_SWSURFACE 0

Just here for compatibility

Definition at line 52 of file SDL_surface.h.

## Typedef Documentation

## SDL_blit

typedef int(* SDL_blit) (struct SDL_Surface *src, SDL_Rect *srcrect, struct SDL_Surface *dst, SDL_Rect *dstrect)

The type of function used for surface blitting functions.

Definition at line 102 of file SDL_surface.h.

## SDL_BlitMap

typedef struct SDL_BlitMap SDL_BlitMap

Definition at line 64 of file SDL_surface.h.

## Enumeration Type Documentation

## SDL_YUV_CONVERSION_MODE

enum SDL_YUV_CONVERSION_MODE

The formula used for converting between YUV and RGB

Enumerator
SDL_YUV_CONVERSION_JPEG | Full range JPEG
SDL_YUV_CONVERSION_BT601 | BT.601 (the default)
SDL_YUV_CONVERSION_BT709 | BT.709
SDL_YUV_CONVERSION_AUTOMATIC | BT.601 for SD content, BT.709 for HD content

Definition at line 108 of file SDL_surface.h.

{
SDL_YUV_CONVERSION_JPEG, /**< Full range JPEG */
SDL_YUV_CONVERSION_BT601, /**< BT.601 (the default) */
SDL_YUV_CONVERSION_BT709, /**< BT.709 */
SDL_YUV_CONVERSION_AUTOMATIC /**< BT.601 for SD content, BT.709 for HD content */
} SDL_YUV_CONVERSION_MODE;
SDL_YUV_CONVERSION_MODE
SDL_YUV_CONVERSION_MODE
Definition SDL_surface.h:109
SDL_YUV_CONVERSION_BT601
@ SDL_YUV_CONVERSION_BT601
Definition SDL_surface.h:111
SDL_YUV_CONVERSION_JPEG
@ SDL_YUV_CONVERSION_JPEG
Definition SDL_surface.h:110
SDL_YUV_CONVERSION_BT709
@ SDL_YUV_CONVERSION_BT709
Definition SDL_surface.h:112
SDL_YUV_CONVERSION_AUTOMATIC
@ SDL_YUV_CONVERSION_AUTOMATIC
Definition SDL_surface.h:113

## Function Documentation

## SDL_ConvertPixels()

int SDL_ConvertPixels | ( | int | width,
|  | int | height,
|  | Uint32 | src_format,
|  | const void * | src,
|  | int | src_pitch,
|  | Uint32 | dst_format,
|  | void * | dst,
|  | int | dst_pitch )

extern

Copy a block of pixels of one format to another format.

Parameters

  width | the width of the block to copy, in pixels.
  height | the height of the block to copy, in pixels.
  src_format | an SDL_PixelFormatEnum value of the src pixels format.
  src | a pointer to the source pixels.
  src_pitch | the pitch of the source pixels, in bytes.
  dst_format | an SDL_PixelFormatEnum value of the dst pixels format.
  dst | a pointer to be filled in with new pixel data.
  dst_pitch | the pitch of the destination pixels, in bytes.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_ConvertSurface()

SDL_Surface * SDL_ConvertSurface | ( | SDL_Surface * | src,
|  | const SDL_PixelFormat * | fmt,
|  | Uint32 | flags )

extern

Copy an existing surface to a new surface of the specified format.

This function is used to optimize images for faster repeat blitting. This is accomplished by converting the original and storing the result as a new surface. The new, optimized surface can then be used as the source for future blits, making them faster.

Parameters

  src | the existing SDL_Surface structure to convert.
  fmt | the SDL_PixelFormat structure that the new surface is optimized for.
  flags | the flags are unused and should be set to 0; this is a leftover from SDL 1.2's API.

Returns
  the new SDL_Surface structure that is created or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_AllocFormat
  SDL_ConvertSurfaceFormat
  SDL_CreateRGBSurface

## SDL_ConvertSurfaceFormat()

SDL_Surface * SDL_ConvertSurfaceFormat | ( | SDL_Surface * | src,
|  | Uint32 | pixel_format,
|  | Uint32 | flags )

extern

Copy an existing surface to a new surface of the specified format enum.

This function operates just like SDL_ConvertSurface(), but accepts an SDL_PixelFormatEnum value instead of an SDL_PixelFormat structure. As such, it might be easier to call but it doesn't have access to palette information for the destination surface, in case that would be important.

Parameters

  src | the existing SDL_Surface structure to convert.
  pixel_format | the SDL_PixelFormatEnum that the new surface is optimized for.
  flags | the flags are unused and should be set to 0; this is a leftover from SDL 1.2's API.

Returns
  the new SDL_Surface structure that is created or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_AllocFormat
  SDL_ConvertSurface
  SDL_CreateRGBSurface

## SDL_CreateRGBSurface()

SDL_Surface * SDL_CreateRGBSurface | ( | Uint32 | flags,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | Uint32 | Rmask,
|  | Uint32 | Gmask,
|  | Uint32 | Bmask,
|  | Uint32 | Amask )

extern

Allocate a new RGB surface.

If depth is 4 or 8 bits, an empty palette is allocated for the surface. If depth is greater than 8 bits, the pixel format is set using the [RGBA]mask parameters.

The [RGBA]mask parameters are the bitmasks used to extract that color from a pixel. For instance, Rmask being 0xFF000000 means the red data is stored in the most significant byte. Using zeros for the RGB masks sets a default value, based on the depth. For example:

SDL_CreateRGBSurface(0,w,h,32,0,0,0,0);
SDL_CreateRGBSurface
SDL_Surface * SDL_CreateRGBSurface(Uint32 flags, int width, int height, int depth, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask)

However, using zero for the Amask results in an Amask of 0.

By default surfaces with an alpha mask are set up for blending as with:

SDL_SetSurfaceBlendMode(surface, SDL_BLENDMODE_BLEND)
SDL_SetSurfaceBlendMode
int SDL_SetSurfaceBlendMode(SDL_Surface *surface, SDL_BlendMode blendMode)

You can change this by calling SDL_SetSurfaceBlendMode() and selecting a different blendMode.

Parameters

  flags | the flags are unused and should be set to 0.
  width | the width of the surface.
  height | the height of the surface.
  depth | the depth of the surface in bits.
  Rmask | the red mask for the pixels.
  Gmask | the green mask for the pixels.
  Bmask | the blue mask for the pixels.
  Amask | the alpha mask for the pixels.

Returns
  the new SDL_Surface structure that is created or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateRGBSurfaceFrom
  SDL_CreateRGBSurfaceWithFormat
  SDL_FreeSurface

## SDL_CreateRGBSurfaceFrom()

SDL_Surface * SDL_CreateRGBSurfaceFrom | ( | void * | pixels,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | pitch,
|  | Uint32 | Rmask,
|  | Uint32 | Gmask,
|  | Uint32 | Bmask,
|  | Uint32 | Amask )

extern

Allocate a new RGB surface with existing pixel data.

This function operates mostly like SDL_CreateRGBSurface(), except it does not allocate memory for the pixel data, instead the caller provides an existing buffer of data for the surface to use.

No copy is made of the pixel data. Pixel data is not managed automatically; you must free the surface before you free the pixel data.

Parameters

  pixels | a pointer to existing pixel data.
  width | the width of the surface.
  height | the height of the surface.
  depth | the depth of the surface in bits.
  pitch | the pitch of the surface in bytes.
  Rmask | the red mask for the pixels.
  Gmask | the green mask for the pixels.
  Bmask | the blue mask for the pixels.
  Amask | the alpha mask for the pixels.

Returns
  the new SDL_Surface structure that is created or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateRGBSurface
  SDL_CreateRGBSurfaceWithFormat
  SDL_CreateRGBSurfaceWithFormatFrom
  SDL_FreeSurface

## SDL_CreateRGBSurfaceWithFormat()

SDL_Surface * SDL_CreateRGBSurfaceWithFormat | ( | Uint32 | flags,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | Uint32 | format )

extern

Allocate a new RGB surface with a specific pixel format.

This function operates mostly like SDL_CreateRGBSurface(), except instead of providing pixel color masks, you provide it with a predefined format from SDL_PixelFormatEnum.

Parameters

  flags | the flags are unused and should be set to 0.
  width | the width of the surface.
  height | the height of the surface.
  depth | the depth of the surface in bits.
  format | the SDL_PixelFormatEnum for the new surface's pixel format.

Returns
  the new SDL_Surface structure that is created or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_CreateRGBSurface
  SDL_CreateRGBSurfaceFrom
  SDL_FreeSurface

## SDL_CreateRGBSurfaceWithFormatFrom()

SDL_Surface * SDL_CreateRGBSurfaceWithFormatFrom | ( | void * | pixels,
|  | int | width,
|  | int | height,
|  | int | depth,
|  | int | pitch,
|  | Uint32 | format )

extern

Allocate a new RGB surface with with a specific pixel format and existing pixel data.

This function operates mostly like SDL_CreateRGBSurfaceFrom(), except instead of providing pixel color masks, you provide it with a predefined format from SDL_PixelFormatEnum.

No copy is made of the pixel data. Pixel data is not managed automatically; you must free the surface before you free the pixel data.

Parameters

  pixels | a pointer to existing pixel data.
  width | the width of the surface.
  height | the height of the surface.
  depth | the depth of the surface in bits.
  pitch | the pitch of the surface in bytes.
  format | the SDL_PixelFormatEnum for the new surface's pixel format.

Returns
  the new SDL_Surface structure that is created or NULL if it fails; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.5.

See also
  SDL_CreateRGBSurfaceFrom
  SDL_CreateRGBSurfaceWithFormat
  SDL_FreeSurface

## SDL_DuplicateSurface()

SDL_Surface * SDL_DuplicateSurface | ( | SDL_Surface * | surface | ) |

extern

## SDL_FillRect()

int SDL_FillRect | ( | SDL_Surface * | dst,
|  | const SDL_Rect * | rect,
|  | Uint32 | color )

extern

Perform a fast fill of a rectangle with a specific color.

color should be a pixel of the format used by the surface, and can be generated by SDL_MapRGB() or SDL_MapRGBA(). If the color value contains an alpha component then the destination is simply filled with that alpha information, no blending takes place.

If there is a clip rectangle set on the destination (set via SDL_SetClipRect()), then this function will fill based on the intersection of the clip rectangle and rect.

Parameters

  dst | the SDL_Surface structure that is the drawing target.
  rect | the SDL_Rect structure representing the rectangle to fill, or NULL to fill the entire surface.
  color | the color to fill with.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_FillRects

## SDL_FillRects()

int SDL_FillRects | ( | SDL_Surface * | dst,
|  | const SDL_Rect * | rects,
|  | int | count,
|  | Uint32 | color )

extern

Perform a fast fill of a set of rectangles with a specific color.

color should be a pixel of the format used by the surface, and can be generated by SDL_MapRGB() or SDL_MapRGBA(). If the color value contains an alpha component then the destination is simply filled with that alpha information, no blending takes place.

If there is a clip rectangle set on the destination (set via SDL_SetClipRect()), then this function will fill based on the intersection of the clip rectangle and rect.

Parameters

  dst | the SDL_Surface structure that is the drawing target.
  rects | an array of SDL_Rect representing the rectangles to fill.
  count | the number of rectangles in the array.
  color | the color to fill with.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_FillRect

## SDL_FreeSurface()

void SDL_FreeSurface | ( | SDL_Surface * | surface | ) |

extern

Free an RGB surface.

It is safe to pass NULL to this function.

Parameters

  surface | the SDL_Surface to free.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_CreateRGBSurface
  SDL_CreateRGBSurfaceFrom
  SDL_LoadBMP
  SDL_LoadBMP_RW

## SDL_GetClipRect()

void SDL_GetClipRect | ( | SDL_Surface * | surface,
|  | SDL_Rect * | rect )

extern

Get the clipping rectangle for a surface.

When surface is the destination of a blit, only the area within the clip rectangle is drawn into.

Parameters

  surface | the SDL_Surface structure representing the surface to be clipped.
  rect | an SDL_Rect structure filled in with the clipping rectangle for the surface.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface
  SDL_SetClipRect

## SDL_GetColorKey()

int SDL_GetColorKey | ( | SDL_Surface * | surface,
|  | Uint32 * | key )

extern

Get the color key (transparent pixel) for a surface.

The color key is a pixel of the format used by the surface, as generated by SDL_MapRGB().

If the surface doesn't have color key enabled this function returns -1.

Parameters

  surface | the SDL_Surface structure to query.
  key | a pointer filled in with the transparent pixel.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface
  SDL_SetColorKey

## SDL_GetSurfaceAlphaMod()

int SDL_GetSurfaceAlphaMod | ( | SDL_Surface * | surface,
|  | Uint8 * | alpha )

extern

Get the additional alpha value used in blit operations.

Parameters

  surface | the SDL_Surface structure to query.
  alpha | a pointer filled in with the current alpha value.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetSurfaceColorMod
  SDL_SetSurfaceAlphaMod

## SDL_GetSurfaceBlendMode()

int SDL_GetSurfaceBlendMode | ( | SDL_Surface * | surface,
|  | SDL_BlendMode * | blendMode )

extern

Get the blend mode used for blit operations.

Parameters

  surface | the SDL_Surface structure to query.
  blendMode | a pointer filled in with the current SDL_BlendMode.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_SetSurfaceBlendMode

## SDL_GetSurfaceColorMod()

int SDL_GetSurfaceColorMod | ( | SDL_Surface * | surface,
|  | Uint8 * | r,
|  | Uint8 * | g,
|  | Uint8 * | b )

extern

Get the additional color value multiplied into blit operations.

Parameters

  surface | the SDL_Surface structure to query.
  r | a pointer filled in with the current red color value.
  g | a pointer filled in with the current green color value.
  b | a pointer filled in with the current blue color value.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetSurfaceAlphaMod
  SDL_SetSurfaceColorMod

## SDL_GetYUVConversionMode()

SDL_YUV_CONVERSION_MODE SDL_GetYUVConversionMode | ( | void |  | ) |

extern

Get the YUV conversion mode

Since
  This function is available since SDL 2.0.8.

## SDL_GetYUVConversionModeForResolution()

SDL_YUV_CONVERSION_MODE SDL_GetYUVConversionModeForResolution | ( | int | width,
|  | int | height )

extern

Get the YUV conversion mode, returning the correct mode for the resolution when the current conversion mode is SDL_YUV_CONVERSION_AUTOMATIC

Since
  This function is available since SDL 2.0.8.

## SDL_HasColorKey()

SDL_bool SDL_HasColorKey | ( | SDL_Surface * | surface | ) |

extern

Returns whether the surface has a color key

It is safe to pass a NULL surface here; it will return SDL_FALSE.

Parameters

  surface | the SDL_Surface structure to query.

Returns
  SDL_TRUE if the surface has a color key, SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.9.

See also
  SDL_SetColorKey
  SDL_GetColorKey

## SDL_HasSurfaceRLE()

SDL_bool SDL_HasSurfaceRLE | ( | SDL_Surface * | surface | ) |

extern

Returns whether the surface is RLE enabled

It is safe to pass a NULL surface here; it will return SDL_FALSE.

Parameters

  surface | the SDL_Surface structure to query.

Returns
  SDL_TRUE if the surface is RLE enabled, SDL_FALSE otherwise.

Since
  This function is available since SDL 2.0.14.

See also
  SDL_SetSurfaceRLE

## SDL_LoadBMP_RW()

SDL_Surface * SDL_LoadBMP_RW | ( | SDL_RWops * | src,
|  | int | freesrc )

extern

Load a BMP image from a seekable SDL data stream.

The new surface should be freed with SDL_FreeSurface(). Not doing so will result in a memory leak.

src is an open SDL_RWops buffer, typically loaded with SDL_RWFromFile. Alternatively, you might also use the macro SDL_LoadBMP to load a bitmap from a file, convert it to an SDL_Surface and then close the file.

Parameters

  src | the data stream for the surface.
  freesrc | non-zero to close the stream after being read.

Returns
  a pointer to a new SDL_Surface structure or NULL if there was an error; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_FreeSurface
  SDL_RWFromFile
  SDL_LoadBMP
  SDL_SaveBMP_RW

## SDL_LockSurface()

int SDL_LockSurface | ( | SDL_Surface * | surface | ) |

extern

Set up a surface for directly accessing the pixels.

Between calls to SDL_LockSurface() / SDL_UnlockSurface(), you can write to and read from surface->pixels, using the pixel format stored in surface->format. Once you are done accessing the surface, you should use SDL_UnlockSurface() to release it.

Not all surfaces require locking. If SDL_MUSTLOCK(surface) evaluates to 0, then you can read and write to the surface at any time, and the pixel format of the surface will not change.

Parameters

  surface | the SDL_Surface structure to be locked.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_MUSTLOCK
  SDL_UnlockSurface

## SDL_LowerBlit()

int SDL_LowerBlit | ( | SDL_Surface * | src,
|  | SDL_Rect * | srcrect,
|  | SDL_Surface * | dst,
|  | SDL_Rect * | dstrect )

extern

Perform low-level surface blitting only.

This is a semi-private blit function and it performs low-level surface blitting, assuming the input rectangles have already been clipped.

Unless you know what you're doing, you should be using SDL_BlitSurface() instead.

Parameters

  src | the SDL_Surface structure to be copied from.
  srcrect | the SDL_Rect structure representing the rectangle to be copied, or NULL to copy the entire surface.
  dst | the SDL_Surface structure that is the blit target.
  dstrect | the SDL_Rect structure representing the rectangle that is copied into.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface

## SDL_LowerBlitScaled()

int SDL_LowerBlitScaled | ( | SDL_Surface * | src,
|  | SDL_Rect * | srcrect,
|  | SDL_Surface * | dst,
|  | SDL_Rect * | dstrect )

extern

Perform low-level surface scaled blitting only.

This is a semi-private function and it performs low-level surface blitting, assuming the input rectangles have already been clipped.

Parameters

  src | the SDL_Surface structure to be copied from.
  srcrect | the SDL_Rect structure representing the rectangle to be copied.
  dst | the SDL_Surface structure that is the blit target.
  dstrect | the SDL_Rect structure representing the rectangle that is copied into.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitScaled

## SDL_PremultiplyAlpha()

int SDL_PremultiplyAlpha | ( | int | width,
|  | int | height,
|  | Uint32 | src_format,
|  | const void * | src,
|  | int | src_pitch,
|  | Uint32 | dst_format,
|  | void * | dst,
|  | int | dst_pitch )

extern

Premultiply the alpha on a block of pixels.

This is safe to use with src == dst, but not for other overlapping areas.

This function is currently only implemented for SDL_PIXELFORMAT_ARGB8888.

Parameters

  width | the width of the block to convert, in pixels.
  height | the height of the block to convert, in pixels.
  src_format | an SDL_PixelFormatEnum value of the src pixels format.
  src | a pointer to the source pixels.
  src_pitch | the pitch of the source pixels, in bytes.
  dst_format | an SDL_PixelFormatEnum value of the dst pixels format.
  dst | a pointer to be filled in with premultiplied pixel data.
  dst_pitch | the pitch of the destination pixels, in bytes.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.18.

## SDL_SaveBMP_RW()

int SDL_SaveBMP_RW | ( | SDL_Surface * | surface,
|  | SDL_RWops * | dst,
|  | int | freedst )

extern

Save a surface to a seekable SDL data stream in BMP format.

Surfaces with a 24-bit, 32-bit and paletted 8-bit format get saved in the BMP directly. Other RGB formats with 8-bit or higher get converted to a 24-bit surface or, if they have an alpha mask or a colorkey, to a 32-bit surface before they are saved. YUV and paletted 1-bit and 4-bit formats are not supported.

Parameters

  surface | the SDL_Surface structure containing the image to be saved.
  dst | a data stream to save to.
  freedst | non-zero to close the stream after being written.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_LoadBMP_RW
  SDL_SaveBMP

## SDL_SetClipRect()

SDL_bool SDL_SetClipRect | ( | SDL_Surface * | surface,
|  | const SDL_Rect * | rect )

extern

Set the clipping rectangle for a surface.

When surface is the destination of a blit, only the area within the clip rectangle is drawn into.

Note that blits are automatically clipped to the edges of the source and destination surfaces.

Parameters

  surface | the SDL_Surface structure to be clipped.
  rect | the SDL_Rect structure representing the clipping rectangle, or NULL to disable clipping.

Returns
  SDL_TRUE if the rectangle intersects the surface, otherwise SDL_FALSE and blits will be completely clipped.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface
  SDL_GetClipRect

## SDL_SetColorKey()

int SDL_SetColorKey | ( | SDL_Surface * | surface,
|  | int | flag,
|  | Uint32 | key )

extern

Set the color key (transparent pixel) in a surface.

The color key defines a pixel value that will be treated as transparent in a blit. For example, one can use this to specify that cyan pixels should be considered transparent, and therefore not rendered.

It is a pixel of the format used by the surface, as generated by SDL_MapRGB().

RLE acceleration can substantially speed up blitting of images with large horizontal runs of transparent pixels. See SDL_SetSurfaceRLE() for details.

Parameters

  surface | the SDL_Surface structure to update.
  flag | SDL_TRUE to enable color key, SDL_FALSE to disable color key.
  key | the transparent pixel.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface
  SDL_GetColorKey

## SDL_SetSurfaceAlphaMod()

int SDL_SetSurfaceAlphaMod | ( | SDL_Surface * | surface,
|  | Uint8 | alpha )

extern

Set an additional alpha value used in blit operations.

When this surface is blitted, during the blit operation the source alpha value is modulated by this alpha value according to the following formula:

srcA = srcA * (alpha / 255)

Parameters

  surface | the SDL_Surface structure to update.
  alpha | the alpha value multiplied into blit operations.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetSurfaceAlphaMod
  SDL_SetSurfaceColorMod

## SDL_SetSurfaceBlendMode()

int SDL_SetSurfaceBlendMode | ( | SDL_Surface * | surface,
|  | SDL_BlendMode | blendMode )

extern

Set the blend mode used for blit operations.

To copy a surface to another surface (or texture) without blending with the existing data, the blendmode of the SOURCE surface should be set to SDL_BLENDMODE_NONE.

Parameters

  surface | the SDL_Surface structure to update.
  blendMode | the SDL_BlendMode to use for blit blending.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetSurfaceBlendMode

## SDL_SetSurfaceColorMod()

int SDL_SetSurfaceColorMod | ( | SDL_Surface * | surface,
|  | Uint8 | r,
|  | Uint8 | g,
|  | Uint8 | b )

extern

Set an additional color value multiplied into blit operations.

When this surface is blitted, during the blit operation each source color channel is modulated by the appropriate color value according to the following formula:

srcC = srcC * (color / 255)

Parameters

  surface | the SDL_Surface structure to update.
  r | the red color value multiplied into blit operations.
  g | the green color value multiplied into blit operations.
  b | the blue color value multiplied into blit operations.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_GetSurfaceColorMod
  SDL_SetSurfaceAlphaMod

## SDL_SetSurfacePalette()

int SDL_SetSurfacePalette | ( | SDL_Surface * | surface,
|  | SDL_Palette * | palette )

extern

Set the palette used by a surface.

A single palette can be shared with many surfaces.

Parameters

  surface | the SDL_Surface structure to update.
  palette | the SDL_Palette structure to use.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

## SDL_SetSurfaceRLE()

int SDL_SetSurfaceRLE | ( | SDL_Surface * | surface,
|  | int | flag )

extern

Set the RLE acceleration hint for a surface.

If RLE is enabled, color key and alpha blending blits are much faster, but the surface must be locked before directly accessing the pixels.

Parameters

  surface | the SDL_Surface structure to optimize.
  flag | 0 to disable, non-zero to enable RLE acceleration.

Returns
  0 on success or a negative error code on failure; call SDL_GetError() for more information.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface
  SDL_LockSurface
  SDL_UnlockSurface

## SDL_SetYUVConversionMode()

void SDL_SetYUVConversionMode | ( | SDL_YUV_CONVERSION_MODE | mode | ) |

extern

Set the YUV conversion mode

Since
  This function is available since SDL 2.0.8.

## SDL_SoftStretch()

int SDL_SoftStretch | ( | SDL_Surface * | src,
|  | const SDL_Rect * | srcrect,
|  | SDL_Surface * | dst,
|  | const SDL_Rect * | dstrect )

extern

Perform a fast, low quality, stretch blit between two surfaces of the same format.

Please use SDL_BlitScaled() instead.

Since
  This function is available since SDL 2.0.0.

## SDL_SoftStretchLinear()

int SDL_SoftStretchLinear | ( | SDL_Surface * | src,
|  | const SDL_Rect * | srcrect,
|  | SDL_Surface * | dst,
|  | const SDL_Rect * | dstrect )

extern

Perform bilinear scaling between two surfaces of the same format, 32BPP.

Since
  This function is available since SDL 2.0.16.

## SDL_UnlockSurface()

void SDL_UnlockSurface | ( | SDL_Surface * | surface | ) |

extern

Release a surface after directly accessing the pixels.

Parameters

  surface | the SDL_Surface structure to be unlocked.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_LockSurface

## SDL_UpperBlit()

int SDL_UpperBlit | ( | SDL_Surface * | src,
|  | const SDL_Rect * | srcrect,
|  | SDL_Surface * | dst,
|  | SDL_Rect * | dstrect )

extern

Perform a fast blit from the source surface to the destination surface.

SDL_UpperBlit() has been replaced by SDL_BlitSurface(), which is merely a macro for this function with a less confusing name.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitSurface

## SDL_UpperBlitScaled()

int SDL_UpperBlitScaled | ( | SDL_Surface * | src,
|  | const SDL_Rect * | srcrect,
|  | SDL_Surface * | dst,
|  | SDL_Rect * | dstrect )

extern

Perform a scaled surface copy to a destination surface.

SDL_UpperBlitScaled() has been replaced by SDL_BlitScaled(), which is merely a macro for this function with a less confusing name.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_BlitScaled